#line 1 "C:/Documents and Settings/Nart Schinackow/Desktop/SoftWare Max7219 Project/MyProject.c"
#line 1 "c:/documents and settings/nart schinackow/desktop/software max7219 project/softmax7219.h"
extern sfr sbit MAX7219_SDO;
extern sfr sbit MAX7219_SDI;
extern sfr sbit MAX7219_SCK;
extern sfr sbit MAX7219_CS;


extern sfr sbit MAX7219_SDO_DIRECTION;
extern sfr sbit MAX7219_SDI_DIRECTION;
extern sfr sbit MAX7219_SCK_DIRECTION;
extern sfr sbit MAX7219_CS_DIRECTION;
#line 1 "c:/documents and settings/nart schinackow/desktop/software max7219 project/softmax7219spi.c"
void Soft7219SpiWriteByte(char DataByte)
{
char ret;
unsigned char mask;

MAX7219_SCK=0;
mask = 0x80;
ret = 0;

do {
MAX7219_SDO=0;
if (DataByte & mask)MAX7219_SDO=1;
MAX7219_SCK=1;
if (MAX7219_SDI) ret |= mask;
delay_us(1);
MAX7219_SCK=0;
mask = mask >> 1;
delay_us(1);
} while (mask != 0);


}


char Soft7219SpiReadByte(char Clock)
{
char ret;
unsigned char mask;

MAX7219_SCK=0;
mask = 0x80;
ret = 0;

do {
MAX7219_SDO=0;
if (Clock & mask)MAX7219_SDO=1;
MAX7219_SCK=1;
if (MAX7219_SDI) ret |= mask;
delay_us(1);
MAX7219_SCK=0;
mask = mask >> 1;
delay_us(1);
} while (mask != 0);

return ret;
}
#line 1 "c:/documents and settings/nart schinackow/desktop/software max7219 project/softmax7219.c"
void SoftMax7219Init()
{
 MAX7219_CS=1;
 MAX7219_SDO=0;
 MAX7219_SDI=0;
 MAX7219_SCK=0;
 MAX7219_CS_DIRECTION=0;
 MAX7219_SDO_DIRECTION=0;
 MAX7219_SDI_DIRECTION=1;
 MAX7219_SCK_DIRECTION=0;

 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x09);
 Soft7219SpiWriteByte(0x0f);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0a);
 Soft7219SpiWriteByte(0x0f);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0b);
 Soft7219SpiWriteByte(0x03);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0c);
 Soft7219SpiWriteByte(0x01);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x00);
 Soft7219SpiWriteByte(0xff);
 MAX7219_CS=1;
}

void SoftMax7219Print(unsigned int Number)
{
 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x01);
 Soft7219SpiWriteByte((Number/1000)%10);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x02);
 Soft7219SpiWriteByte((Number/100)%10);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x03);
 Soft7219SpiWriteByte((Number/10)%10);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x04);
 Soft7219SpiWriteByte(Number%10);
 MAX7219_CS=1;
}


void SoftMax7219DisplayOff()
{
 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0c);
 Soft7219SpiWriteByte(0x00);
 MAX7219_CS=1;
}

void SoftMax7219DisplayOn()
{
 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0c);
 Soft7219SpiWriteByte(0x01);
 MAX7219_CS=1;
}
#line 18 "c:/documents and settings/nart schinackow/desktop/software max7219 project/softmax7219.h"
struct SoftMax7219Struct
{
 void (*Init)();
 void (*Print)(unsigned int Number);
 void (*TurnOff)();
 void (*TurnOn)();
}SoftDisplay={&SoftMax7219Init,&SoftMax7219Print,&SoftMax7219DisplayOff,&SoftMax7219DisplayOn};
#line 23 "C:/Documents and Settings/Nart Schinackow/Desktop/SoftWare Max7219 Project/MyProject.c"
sfr sbit MAX7219_SDO at RB5_bit;
sfr sbit MAX7219_SDI at RB6_bit;
sfr sbit MAX7219_SCK at RB7_bit;
sfr sbit MAX7219_CS at RC0_bit;


sfr sbit MAX7219_SDO_DIRECTION at TRISB5_bit;
sfr sbit MAX7219_SDI_DIRECTION at TRISB6_bit;
sfr sbit MAX7219_SCK_DIRECTION at TRISB7_bit;
sfr sbit MAX7219_CS_DIRECTION at TRISC0_bit;





unsigned int i;


void main()
{
 SoftDisplay.Init();

 SoftDisplay.Print(0);

 for(i=0;i<10;i++)
 {
 SoftDisplay.TurnOff();
 delay_ms(100);
 SoftDisplay.TurnOn();
 delay_ms(100);
 }

 while(1)
 {
 for(i=0;i<512;i++)
 {
 SoftDisplay.Print(i);
 delay_ms(100);
 }
 }

}
